-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassJoystick.chs

-- 

module HGamer3D.Bindings.SFML.ClassJoystick where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.SFML.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}
import HGamer3D.Bindings.SFML.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}
import HGamer3D.Bindings.SFML.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}
import HGamer3D.Bindings.SFML.EnumJoystickAxis
{-# LINE 43 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}

-- | Check if a joystick is connected. 
isConnected :: Int  -- ^ joystick - Index of the joystick to check
  ->  IO (Bool)
 -- ^ return value - True if the joystick is connected, false otherwise     
isConnected a1 =
  let {a1' = fromIntegral a1} in 
  alloca $ \a2' -> 
  isConnected'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 49 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}

-- | Return the number of buttons supported by a joystick.  - Details: If the joystick is not connected, this function returns 0.
getButtonCount :: Int  -- ^ joystick
  ->  IO (Int)
 -- ^ 
getButtonCount a1 =
  let {a1' = fromIntegral a1} in 
  alloca $ \a2' -> 
  getButtonCount'_ a1' a2' >>= \res ->
  peekIntConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 54 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}

-- | Check if a joystick supports a given axis.  - Details: If the joystick is not connected, this function returns false.
hasAxis :: Int  -- ^ joystick
  ->  EnumJoystickAxis  -- ^ axis
  ->  IO (Bool)
 -- ^ 
hasAxis a1 a2 =
  let {a1' = fromIntegral a1} in 
  let {a2' = cIntFromEnum a2} in 
  alloca $ \a3' -> 
  hasAxis'_ a1' a2' a3' >>= \res ->
  peekBoolUtil  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 60 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}

-- | Check if a joystick button is pressed.  - Details: If the joystick is not connected, this function returns false.
isButtonPressed :: Int  -- ^ joystick
  ->  Int  -- ^ button
  ->  IO (Bool)
 -- ^ 
isButtonPressed a1 a2 =
  let {a1' = fromIntegral a1} in 
  let {a2' = fromIntegral a2} in 
  alloca $ \a3' -> 
  isButtonPressed'_ a1' a2' a3' >>= \res ->
  peekBoolUtil  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 66 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}

-- | Get the current position of a joystick axis.  - Details: If the joystick is not connected, this function returns 0.
getAxisPosition :: Int  -- ^ joystick
  ->  EnumJoystickAxis  -- ^ axis
  ->  IO (Float)
 -- ^ 
getAxisPosition a1 a2 =
  let {a1' = fromIntegral a1} in 
  let {a2' = cIntFromEnum a2} in 
  alloca $ \a3' -> 
  getAxisPosition'_ a1' a2' a3' >>= \res ->
  peekFloatConv  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 72 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}

-- | Update the states of all joysticks.  - Details: This function is used internally by SFML, so you normally don't have to call it explicitely. However, you may need to call it if you have no window yet (or no window at all): in this case the joysticks states are not updated automatically. 
update :: IO ()
 -- ^ 
update =
  update'_ >>= \res ->
  return ()
{-# LINE 76 ".\\HGamer3D\\Bindings\\SFML\\ClassJoystick.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\SFML\\ClassJoystick.chs.h sfml_jst_isConnected"
  isConnected'_ :: (CUInt -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\SFML\\ClassJoystick.chs.h sfml_jst_getButtonCount"
  getButtonCount'_ :: (CUInt -> ((Ptr CUInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\SFML\\ClassJoystick.chs.h sfml_jst_hasAxis"
  hasAxis'_ :: (CUInt -> (CInt -> ((Ptr CInt) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\SFML\\ClassJoystick.chs.h sfml_jst_isButtonPressed"
  isButtonPressed'_ :: (CUInt -> (CUInt -> ((Ptr CInt) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\SFML\\ClassJoystick.chs.h sfml_jst_getAxisPosition"
  getAxisPosition'_ :: (CUInt -> (CInt -> ((Ptr CFloat) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\SFML\\ClassJoystick.chs.h sfml_jst_update"
  update'_ :: (IO ())
